"""1.1.0 Improve fazwynn relationships

Revision ID: 3173276fb06a
Revises: 3965042b4d49
Create Date: 2024-10-27 19:10:08.450598

"""

from typing import Sequence, Union

from alembic import op

# revision identifiers, used by Alembic.
revision: str = "3173276fb06a"
down_revision: Union[str, None] = "3965042b4d49"
branch_labels: Union[str, Sequence[str], None] = None
depends_on: Union[str, Sequence[str], None] = None


# fmt: off
def upgrade() -> None:
    op.execute("ALTER TABLE guild_history ADD COLUMN uuid BINARY(16);")
    op.execute("UPDATE guild_history gh SET uuid = ( SELECT gi.uuid FROM guild_info gi WHERE gi.name = gh.name AND gi.created <= gh.datetime ORDER BY gi.created DESC LIMIT 1);")
    op.execute("DELETE FROM `guild_history` WHERE `uuid` IS NULL;")
    op.execute("ALTER TABLE `guild_history` DROP PRIMARY KEY;")
    op.execute("ALTER TABLE `guild_history` DROP COLUMN `name`;")
    op.execute("ALTER TABLE `guild_history` ADD PRIMARY KEY (`uuid`, `datetime`);")

    # ### commands auto generated by Alembic - please adjust! ###
    op.create_foreign_key(None, "player_history", "player_info", ["uuid"], ["uuid"],)
    op.create_foreign_key(None, "guild_history", "guild_info", ["uuid"], ["uuid"],)
    op.create_foreign_key(None, "character_history", "character_info", ["character_uuid"], ["character_uuid"],)
    op.create_foreign_key(None, "character_info", "player_info", ["uuid"], ["uuid"],)
    op.create_index(None, "character_history", ["character_uuid"], unique=False,)
    op.create_index(None, "guild_history", ["uuid"], unique=False)
    op.create_index(None, "guild_member_history", ["uuid"], unique=False,)
    op.create_index(None, "player_history", ["uuid"], unique=False)
    # ### end Alembic commands ###

def downgrade() -> None:
    op.drop_constraint(op.f("fk_guild_history_uuid_guild_info"), "guild_history", type_="foreignkey")
    op.drop_index(op.f("ix_guild_history_uuid"), table_name="guild_history")
    op.execute("ALTER TABLE `guild_history` DROP PRIMARY KEY;")
    op.execute("ALTER TABLE `guild_history` DROP COLUMN `uuid`;")
    op.execute("ALTER TABLE `guild_history` ADD COLUMN `name` VARCHAR(30) NOT NULL;")
    op.execute("ALTER TABLE `guild_history` ADD PRIMARY KEY (`name`, `datetime`);")

    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_constraint(op.f("fk_player_history_uuid_player_info"), "player_history", type_="foreignkey")
    op.drop_index(op.f("ix_player_history_uuid"), table_name="player_history")
    op.drop_index(op.f("ix_guild_member_history_uuid"), table_name="guild_member_history")
    op.drop_constraint(op.f("fk_character_info_uuid_player_info"),"character_info", type_="foreignkey")
    op.drop_constraint(op.f("fk_character_history_character_uuid_character_info"), "character_history", type_="foreignkey",)
    op.drop_index(op.f("ix_character_history_character_uuid"), table_name="character_history")
    # ### end Alembic commands ###
# fmt: on
